@-------------------------@
@ Warhawk Main Game Code  @
@ Flash & HeadKaze 2009   @
@-------------------------@
@ V0.06 - FLASH
@ - Minor ammendment to BG2 & BG3, now 32x64
@ V0.05 - FLASH
@ - Added code to enable scrolling in the horizonal based on ship position.
@ - Added code to stop map scroll at exact end (need a bit more space at top of level)
@ - Added code to wrap background scrolls:-
@ - 	Spent 2 hours to add 2 lines (Still - you gotta laugh)
@ -			cmp r1,#0		
@ -			moveq r1,#832
@ - 	(turns out I had not drawn the wrap in the pngs correctly - AARGH!)
@ - Tidyed code
@ - Created InitData - We MUST reset all data at start of level (except bg map scrolls)
@ - Added basic wobble effect to end of level (Looks too much like snow IMHO)
@ - Cannot get sprites to re-plot, this must be done during Vblank apparently??
@ v0.04 - HK
@ - Fixed bg2 not showing on hardware
@ - Added new StarBack / StarFront graphics
@ v0.03 - FLASH
@ - Have used the same palette for all layers
@ - Moved init code away from main code
@ - Added ship and minor control code
@ - Tidy of code
@ -added delay to game start
@ v0.02 - HK
@ - Removed BG_PALETTE(n) because there are no macros for them
@ - Changed to use adrl
@ - Tried to use the -ga and -ps to offset the palettes but didnt work :(
@ V0.01 - Flash
@ - Added 2 backgrounds StarBack and StarFront
@ Duplicated code for the 3 scrollers and init memory for tiles and map data
@----------------------------------------------------------------------------------------------------------@

#include "system.h"
#include "video.h"
#include "background.h"
#include "dma.h"
#include "interrupts.h"
#include "sprite.h"

	.arm
	.align
	.global initSystem
	.global main

initSystem:
	bx lr

main:
	@ Setup the screens and the sprites
	
	bl InitScreens
	bl InitSprites
	bl InitData

	@ firstly, lets draw all the screen data ready for play
	@ and display the ship sprite
	
	bl WaitforVblank
	bl drawMapMain
	bl drawMapSub
	bl drawSFMapMain
	bl drawSFMapSub
	bl drawSBMapMain
	bl drawSBMapSub
	bl drawShip
	
	bl WaitforFire

@----------------------------@	
@ This is the MAIN game loop @
@----------------------------@
GameLoop:

	bl WaitforVblank

	bl StarScroll		@ Scroll Stars (BG2,BG3)
	bl LevelDrift
	
	bl CheckEndOfLevel	@ Set Flag for end-of-level (use later to init BOSS)
	
	bl scrollMain		@ Scroll Level Data
	bl scrollSub		@ Main + Sub
	
	bl moveShip			@ Move our craft (d-pad and A, perhaps check for pause and shut DS)

	bl WaitforNoblank
	
	b GameLoop			@ our main loop
	
end:
	b end


@-------------------- From here on are all the subroutines and data -------------------@
LevelDrift:
	ldrb r0, horizDrift
	ldr r1, =REG_BG1HOFS			@ Load our horizontal scroll register for BG1 on the main screen
	ldr r2, =REG_BG1HOFS_SUB		@ Load our horizontal scroll register for BG1 on the sub screen
	strh r0,[r1]
	strh r0,[r2]
	mov r15,r14
StarScroll:
	stmfd sp!, {r0-r6, lr} 
	ldr r1,delaySF							@ Delay Starfront for every other update
	subs r1, #1
	bne noscrollSF
		bl scrollSFMain
		bl scrollSFSub
		mov r1,#2
	noscrollSF:
	str r1,delaySF	
	ldr r1,delaySB							@ Delay Starback for every 4 updates
	subs r1,#1
	bne noscrollSB
		bl scrollSBMain
		bl scrollSBSub
		mov r1,#4
	noscrollSB:
	str r1,delaySB
	ldmfd sp!, {r0-r6, pc}
	
CheckEndOfLevel:
	ldrb r0,LevelEnd
	cmp r0,#0
	bne LevelPlay
		ldr r0,yposSub						@ Ypos is the Y position in the map data
		ldr r1,vofsSub
		orr r0, r1
		cmp r0, #0							@ are we at ZERO - top of the map?
		bne LevelPlay						@ If so, and scroll is 0 also - Stop Main Scroll!
			mov r0,#1
			strb r0,LevelEnd
	LevelPlay:
	mov r15,r14

WaitforVblank:
	stmfd sp!, {r0-r6, lr} 
	
	ldrb r0,LevelEnd
	cmp r0,#0
	beq LevelBlank
		@ Do our effect for the boss battle!
		adrl r3,[sinus1]				@ address of sine	
		ldr r5,=REG_BG2HOFS_SUB			@ Preset memory adresses for Horiz Scroll
		ldr r6,=REG_BG2HOFS
		ldr r7,=REG_BG3HOFS_SUB
		ldr r8,=REG_BG3HOFS
		mov r1,#0						@ r1 is our sine/Raster counter
		ldr r0, =REG_VCOUNT
		holdonmate:
			ldr r2, [r0]				@ r2 = raster position
			cmp r2,r1					@ check if we are at our raster pos?
		bne holdonmate					@ if not, keep waiting
			ldrb r4,[r3,r1]			@ load r4 with sine1 position plus our raster position offest
			strh r4,[r5]	
			strh r4,[r6]
			strh r4,[r7]
			strh r4,[r8]
			add r1,#1					@ add 1 to the raster count (the raster number we are modifying)
			cmp r1,#193					@ check if we are down to our end position
		bne holdonmate					@ if not, let us do another line
		ldmfd sp!, {r0-r6, pc}
	
	LevelBlank:
	ldr r0, =REG_VCOUNT
	waitVBlankSUB:									
	ldrh r1,[r0]						@ read REG_VCOUNT into r2
	cmp r1, #193						@ 193 is, of course, the first scanline of vblank
	bne waitVBlankSUB					@ loop if r2 is not equal to (NE condition) 193
	ldmfd sp!, {r0-r6, pc}
	
WaitforNoblank:
	stmfd sp!, {r0-r6, lr} 
	ldr r0, =REG_VCOUNT
	waitVBlankNO:									
	ldrh r1, [r0]						@ read REG_VCOUNT into r2
	cmp r1, #255	
	bne waitVBlankNO
	ldmfd sp!, {r0-r6, pc}

scrollMain:
	stmfd sp!, {r0-r6, lr}
	ldrb r0,LevelEnd
	cmp r0,#0
	bne scrollDone
	adrl r2,[vofsMain]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollMain				@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollMapMain				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG1VOFS			@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen	
	Noscrollmain:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSub:
	stmfd sp!, {r0-r6, lr}
	ldrb r0,LevelEnd
	cmp r0,#0
	bne scrollDone
	adrl r2, [vofsSub]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSub				@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollMapSub				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG1VOFS_SUB		@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	NoscrollSub:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSFMain:
	stmfd sp!, {r0-r6, lr} 

	adrl r2, [vofsSFMain]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSFMain			@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSFMapMain				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG2VOFS			@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSFSub:
	stmfd sp!, {r0-r6, lr}	

	adrl r2, [vofsSFSub]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSFSub			@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSFMapSub				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG2VOFS_SUB		@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSBMain:
	stmfd sp!, {r0-r6, lr} 	

	adrl r2, [vofsSBMain]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSBMain			@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSBMapMain				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG3VOFS			@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen	
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSBSub:
	stmfd sp!, {r0-r6, lr}	

	adrl r2, [vofsSBSub]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSBSub			@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSBMapSub				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG3VOFS_SUB		@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [vofsMain]
	ldr r1, =REG_BG1VOFS			@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [vofsSub]
	ldr r1, =REG_BG1VOFS_SUB		@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollSFMain:
	stmfd sp!, {r0-r6, lr} 

	adrl r0, [vofsSFMain]
	ldr r1, =REG_BG2VOFS			@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSFMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

resetScrollSFSub:
	stmfd sp!, {r0-r6, lr} 

	adrl r0, [vofsSFSub]
	ldr r1, =REG_BG2VOFS_SUB		@ R1 is the memory adress for the sub screen scr
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSFMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

resetScrollSBMain:
	stmfd sp!, {r0-r6, lr} 
	
	adrl r0, [vofsSBMain]
	ldr r1, =REG_BG3VOFS			@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSBMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollSBSub:
	stmfd sp!, {r0-r6, lr} 
	
	adrl r0, [vofsSBSub]
	ldr r1, =REG_BG3VOFS_SUB		@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSBMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollMapMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposMain]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollMapSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSub]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSFMapMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSFMain]			@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	
	cmp r1,#0						@ If we are at the top, lets go back to the
	moveq r1,#832					@ bottom of the map!

	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSFMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSFMapSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSFSub]			@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	
	cmp r1,#0						@ If we are at the top, lets go back to the
	moveq r1,#832					@ bottom of the map!
	
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSFMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSBMapMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSBMain]			@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos

	cmp r1,#0						@ If we are at the top, lets go back to the
	moveq r1,#832					@ bottom of the map!

	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSBMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSBMapSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSBSub]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos

	cmp r1,#0						@ If we are at the top, lets go back to the
	moveq r1,#832					@ bottom of the map!

	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSBMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollDone:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

drawMapMain:
	@ Draw Main Screen
	stmfd sp!, {r0-r6, lr}
	ldr r0, =Level1Map
	ldr r1, =BG_MAP_RAM(19)
	adrl r4, [yposMain]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawMapSub:
	stmfd sp!, {r0-r6, lr}
	@ Draw Sub screen
	ldr r0, =Level1Map
	ldr r1, =BG_MAP_RAM_SUB(21)
	adrl r4, [yposSub]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawSFMapMain:
	@ Draw Main Screen
	stmfd sp!, {r0-r6, lr}
	ldr r0, =StarFrontMap
	ldr r1, =BG_MAP_RAM(23)
	adrl r4, [yposSFMain]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #5				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawSFMapSub:
	stmfd sp!, {r0-r6, lr}
	@ Draw Sub screen
	ldr r0, =StarFrontMap
	ldr r1, =BG_MAP_RAM_SUB(25)
	adrl r4, [yposSFSub]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #5				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawSBMapMain:
	@ Draw Main Screen
	stmfd sp!, {r0-r6, lr}
	ldr r0, =StarBackMap
	ldr r1, =BG_MAP_RAM(27)
	adrl r4, [yposSBMain]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #5				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawSBMapSub:
	stmfd sp!, {r0-r6, lr}
	@ Draw Sub screen
	ldr r0, =StarBackMap
	ldr r1, =BG_MAP_RAM_SUB(29)
	adrl r4, [yposSBSub]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #5				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return

InitScreens:
	stmfd sp!, {r0-r6, lr}
	ldr r0, =REG_POWERCNT
	ldr r1, =POWER_ALL_2D			@ All power on
	str r1, [r0]
 
	mov r0, #REG_DISPCNT			@ Main screen to Mode 0 with BG2 active
	ldr r1, =(MODE_0_2D | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE)
	str r1, [r0]
	
	ldr r0, =REG_DISPCNT_SUB		@ Sub screen to Mode 0 with BG0 active
	ldr r1, =(MODE_0_2D | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE)
	str r1, [r0]
 
	ldr r0, =VRAM_A_CR				@ Set VRAM A to be main bg address 0x06000000
	ldr r1, =(VRAM_ENABLE | VRAM_A_MAIN_BG_0x06000000)
	strb r1, [r0]

	ldr r0, =VRAM_B_CR				@ Use this for sprite data
	ldr r1, =(VRAM_ENABLE | VRAM_A_MAIN_SPRITE)
	strb r1, [r0]
	
	ldr r0, =VRAM_C_CR				@ Set VRAM C to be sub bg address 0x06200000
	ldr r1, =(VRAM_ENABLE | VRAM_C_SUB_BG_0x06200000)
	strb r1, [r0]
	
	ldr r0, =VRAM_D_CR				@ Use this for sprite data
	ldr r1, =(VRAM_ENABLE | VRAM_D_SUB_SPRITE)
	strb r1, [r0]

	ldr r0, =REG_BG0CNT				@ Set main screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_32x32 | BG_MAP_BASE(15) | BG_TILE_BASE(0) | BG_PRIORITY(0))
	strh r1, [r0]
	ldr r0, =REG_BG0CNT_SUB			@ Set sub screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_32x32 | BG_MAP_BASE(17) | BG_TILE_BASE(0) | BG_PRIORITY(0))
	strh r1, [r0]
	
	ldr r0, =REG_BG1CNT				@ Set main screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_64x64 | BG_MAP_BASE(19) | BG_TILE_BASE(1) | BG_PRIORITY(1))
	strh r1, [r0]
	ldr r0, =REG_BG1CNT_SUB			@ Set sub screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_64x64 | BG_MAP_BASE(21) | BG_TILE_BASE(1) | BG_PRIORITY(1))
	strh r1, [r0]
	
	ldr r0, =REG_BG2CNT				@ Set main screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_32x64 | BG_MAP_BASE(23) | BG_TILE_BASE(2) | BG_PRIORITY(2))
	strh r1, [r0]
	ldr r0, =REG_BG2CNT_SUB			@ Set sub screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_32x64 | BG_MAP_BASE(25) | BG_TILE_BASE(2) | BG_PRIORITY(2))
	strh r1, [r0]

	ldr r0, =REG_BG3CNT				@ Set main screen BG3 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_256 | BG_32x64 | BG_MAP_BASE(27) | BG_TILE_BASE(5) | BG_PRIORITY(3))
	strh r1, [r0]
	ldr r0, =REG_BG3CNT_SUB			@ Set sub screen BG3 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_256 | BG_32x64 | BG_MAP_BASE(29) | BG_TILE_BASE(5) | BG_PRIORITY(3))
	strh r1, [r0]
	
	@ Load the palette into the palette subscreen area and main

	ldr r0, =StarBackPal
	ldr r1, =BG_PALETTE
	ldr r2, =512
	bl dmaCopy
	ldr r1, =BG_PALETTE_SUB
	bl dmaCopy
	
	@ Write the tile data to VRAM Level BG1

	ldr r0, =Level1Tiles
	ldr r1, =BG_TILE_RAM(1)
	ldr r2, =11168
	bl dmaCopy
	ldr r1, =BG_TILE_RAM_SUB(1)
	bl dmaCopy
	
	@ Write the tile data to VRAM FrontStar BG2

	ldr r0, =StarFrontTiles
	ldr r1, =BG_TILE_RAM(2)
	ldr r2, =640
	bl dmaCopy
	ldr r1, =BG_TILE_RAM_SUB(2)
	bl dmaCopy

	@ Write the tile data to VRAM BackStar BG3

	ldr r0, =StarBackTiles
	ldr r1, =BG_TILE_RAM(5)
	ldr r2, =34880
	bl dmaCopy
	ldr r1, =BG_TILE_RAM_SUB(5)
	bl dmaCopy

	@ Our horizontal centre routine
	
	ldr r0, =REG_BG1HOFS			@ Load our horizontal scroll register for BG1 on the main screen
	ldr r1, =REG_BG1HOFS_SUB		@ Load our horizontal scroll register for BG1 on the sub screen
	ldr r2, =REG_BG2HOFS			@ Load our horizontal scroll register for BG2 on the main screen
	ldr r3, =REG_BG2HOFS_SUB		@ Load our horizontal scroll register for BG2 on the sub screen
	ldr r4, =REG_BG3HOFS			@ Load our horizontal scroll register for BG3 on the main screen
	ldr r5, =REG_BG3HOFS_SUB		@ Load our horizontal scroll register for BG3 on the sub screen
	mov r6, #32						@ Offset the horizontal scroll register by 32 pixels to centre the map
	strh r6, [r0]					@ Write our offset value to REG_BG1HOFS
	strh r6, [r1]					@ Write our offset value to REG_BG1HOFS_SUB
	mov r6,#0
	strh r6, [r2]					@ Write our offset value to REG_BG2HOFS
	strh r6, [r3]					@ Write our offset value to REG_BG2HOFS_SUB
	strh r6, [r4]					@ Write our offset value to REG_BG3HOFS
	strh r6, [r5]					@ Write our offset value to REG_BG3HOFS_SUB

		
	@ Our vertical scrolling routine

	ldr r0, =REG_BG1VOFS			@ Load our vertical scroll register for BG1 on the main screen
	adrl r2, [vofsMain]				@ Set our scroll counter to start main screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG1VOFS_SUB		@ Load our vertical scroll register for BG1 on the sub screen
	adrl r2, [vofsSub]				@ Set our scroll counter to start sub screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register
	
	ldr r0, =REG_BG2VOFS			@ Load our vertical scroll register for BG2 on the main screen
	adrl r2, [vofsSFMain]			@ Set our scroll counter to start main screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG2VOFS_SUB		@ Load our vertical scroll register for BG2 on the sub screen
	adrl r2, [vofsSFSub]			@ Set our scroll counter to start sub screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG3VOFS			@ Load our vertical scroll register for BG3 on the main screen
	adrl r2, [vofsSBMain]			@ Set our scroll counter to start main screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG3VOFS_SUB		@ Load our vertical scroll register for BG3 on the sub screen
	adrl r2, [vofsSBSub]			@ Set our scroll counter to start sub screen
	ldrh r2, [r2]
	strh r2, [r0]	
	
	ldmfd sp!, {r0-r6, pc} 

InitSprites:
	stmfd sp!, {r0-r6, lr} 

	@ Load the palette into the palette subscreen area and main

	ldr r0, =SpritesPal
	ldr r1, =SPRITE_PALETTE
	ldr r2, =512
	bl dmaCopy
	ldr r1, =SPRITE_PALETTE_SUB
	bl dmaCopy

	@ Write the tile data to VRAM

	ldr r0, =SpritesTiles
	ldr r1, =SPRITE_GFX
	ldr r2, =1024
	bl dmaCopy
	ldr r1, =SPRITE_GFX_SUB
	bl dmaCopy
	
	@ Clear the OAM (disable all 128 sprites for both screens)

	ldr r0, =ATTR0_DISABLED			@ Set OBJ_ATTRIBUTE0 to ATTR0_DISABLED
	ldr r1, =OAM
	ldr r2, =1024					@ 3 x 16bit attributes + 16 bit filler = 8 bytes x 128 entries in OAM
	bl dmaFillWords
	ldr r1, =OAM_SUB
	bl dmaFillWords

	ldmfd sp!, {r0-r6, pc} 
	
WaitforFire:
	@ Messy bit just to wait for button to start
	@ This is a delay that can be skipped by FIRE
	@ Not great, but serves its purpose for now
	@ this will need to update music at later stage also
	
	stmfd sp!, {r0-r6, lr} 
	mov r4,#200
	buttpause:
	
		bl WaitforVblank
	
		bl StarScroll

		bl WaitforNoblank
	
		ldr r1,=REG_KEYINPUT
		ldr r2,[r1]
		and r2,#1
		cmp r2,#0
		beq butta
		subs r4,#1
		bne buttpause
	butta:	
	
	ldmfd sp!, {r0-r6, pc} 
	

drawShip:
	stmfd sp!, {r0-r6, lr} 
	
	ldr r0, =OBJ_ATTRIBUTE0(0)
	ldr r1, =(ATTR0_COLOR_16 | ATTR0_SQUARE)
	strh r1, [r0]
	ldr r0, =OBJ_ATTRIBUTE1(0)
	ldr r1, =(ATTR1_SIZE_32)
	strh r1, [r0]
	ldr r0, =OBJ_ATTRIBUTE2(0)
	ldr r1, =(0 | ATTR2_PRIORITY(0) | ATTR2_PALETTE(0))
	strh r1, [r0]

	ldrb r0,shipY
	ldr r1, =OBJ_ATTRIBUTE0(0)
	strb r0,[r1]
	ldrb r0,shipX
	ldr r1, =OBJ_ATTRIBUTE1(0)
	strb r0,[r1]

	@ldr r0, =OBJ_ATTRIBUTE0(0) @ Plot Y Coord
	@ldrb r1,shipY
	@orr r1,#(ATTR2_PRIORITY(0) | ATTR2_PALETTE(0))
	@strb r1, [r0]

	@ldr r0, =OBJ_ATTRIBUTE1(0) @ Plot x Coord
	@ldrb r1,shipX
	@orr r1,#(ATTR2_PRIORITY(0) | ATTR2_PALETTE(0))
	@strb r1, [r0]	
	
	ldmfd sp!, {r0-r6, pc} 

moveShip:
	stmfd sp!, {r0-r6, lr} 
	ldr r5,=shipY
	ldr r6,=shipX
	ldr r1,=REG_KEYINPUT		@ Read the keys!
	ldrb r7,shipXspeed
	ldrh r2,[r1]				@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#64					@ UP (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck1
	@ Up code
		ldrb r8,[r5]
		subs r8,#2
		bpl dircheck0pass
		mov r8,#0
		dircheck0pass:
		strb r8,[r5]
		b dircheck2
	dircheck1:
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#128					@ DOWN (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck2
	@ Down code
		ldrb r8,[r5]
		adds r8,#2
		cmp r8,#160
		bmi dircheck1pass
		mov r8,#160
		dircheck1pass:
		strb r8,[r5]
	dircheck2:
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#32					@ LEFT (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck3
	@ Left code
		ldrb r8,[r6]
		subs r8,r7
		bpl dircheck2pass
		mov r8,#0
		dircheck2pass:
		strb r8,[r6]
		b dircheck4
	dircheck3:
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#16					@ RIGHT (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck4
	@ Right code
		ldrb r8,[r6]
		adds r8,r7
		cmp r8,#224				@ 256-sprite width
		bmi dircheck3pass
		mov r8,#224
		dircheck3pass:
		strb r8,[r6]
	dircheck4:
	
	ldrb r0,shipY
	ldr r1, =OBJ_ATTRIBUTE0(0)
	strb r0,[r1]
	ldrb r0,shipX
	ldr r1, =OBJ_ATTRIBUTE1(0)
	strb r0,[r1]

	@ Update the Ship with the valid position
	@ldr r0, =OBJ_ATTRIBUTE0(0) @ Plot Y Coord
	@ldr r1,shipY
	@orr r1,#(ATTR2_PRIORITY(0) | ATTR2_PALETTE(0))
	@strb r1, [r0]
	@ldr r0, =OBJ_ATTRIBUTE1(0) @ Plot x Coord
	@ldr r1,shipX
	@orr r1,#(ATTR2_PRIORITY(0) | ATTR2_PALETTE(0))
	@strb r1, [r0]	

	@ Caculate the drift on background (bg1)
	@ Take x and divide by 3.5 store in horizDrift
	
	ldrb r1,shipX
	cmp r1,#64
	bmi leftship
	cmp r1,#192-32
	bpl rightship
		@ Ok, we are in the centre
		mov r0,#2
		strb r0,shipXspeed
		mov r1,#32
		b offdone

	leftship:
		mov r0,#1
		strb r0,shipXspeed
		lsr r1,#1
		b offdone

	rightship:
		mov r0,#1
		strb r0,shipXspeed
		sub r1,#160
		lsr r1,#1
		add r1,#32

	b offdone

	offdone:
	strb r1,horizDrift	
	@ simple code for drift
	@ldrb r1,shipX
	@add r1,#16
	@lsr r1,#2
	@strb r1,horizDrift
	
	ldmfd sp!, {r0-r6, pc} 
	
Divide:
	@ R1 to hold nuber to divide, r2 hold divisor. R0 returns result (hopefully)
	@ Thought this may com in handy - perhaps not?
	stmfd sp!, {r3-r6, lr} 
	mov r0,#0
	mov r3,#1	@ set bit 0 for test in shift
	divl1:
		cmp r2,r1
		movls r2,r2,lsl #1	@ shift r2 till it is same as r1
		movls r3,r3,lsl #1	@ shift r3 (this is our count flag)
	bls divl1
	divl2:
		cmp r1,r2
		subcs r1,r1,r2
		addcs r0,r0,r3
		movs r3,r3,lsr #1
		movcc r2,r2,lsr #1
	bcc divl2
	ldmfd sp!, {r3-r6, pc} 
	
InitData:
	mov r1,#0
	strb r1,LevelEnd
	mov r1,#112
	strb r1,shipX
	mov r1,#160
	strb r1,shipY
	mov r1,#32
	strb r1,horizDrift
	mov r1,#1
	strb r1,shipXspeed
	mov r15,r14
	
	
	.pool
	.align
LevelEnd:
	.word 0
delaySF:
	.word 2
delaySB:
	.word 4

vofsMain:
	.word 192
vofsSFMain:
	.word 192
vofsSBMain:
	.word 192
	
vofsSub:
	.word 0
vofsSFSub:
	.word 0
vofsSBSub:
	.word 0

initOffset:
	.word 832
yposMain:
	.word 832
yposSFMain:
	.word 832
yposSBMain:
	.word 832

yposSub:
	.word 832
yposSFSub:
	.word 832
yposSBSub:
	.word 832
horizDrift:
	.word 0


xpos:
	.word 0
shipX:
	.byte 0
shipY:
	.byte 0
shipXspeed:
	.byte 0
	.byte 0

sinus1:
.byte  34 , 36 , 38 , 40 , 42 , 44 , 46 , 48 
.byte  50 , 51 , 53 , 55 , 56 , 57 , 59 , 60 
.byte  61 , 62 , 62 , 63 , 63 , 64 , 64 , 64 
.byte  64 , 64 , 63 , 63 , 62 , 62 , 61 , 60 
.byte  59 , 57 , 56 , 55 , 53 , 51 , 50 , 48 
.byte  46 , 44 , 42 , 40 , 38 , 36 , 34 , 32 
.byte  30 , 28 , 26 , 24 , 22 , 20 , 18 , 16 
.byte  14 , 13 , 11 , 9 , 8 , 7 , 5 , 4 
.byte  3 , 2 , 2 , 1 , 1 , 0 , 0 , 0 
.byte  0 , 0 , 1 , 1 , 2 , 2 , 3 , 4 
.byte  5 , 7 , 8 , 9 , 11 , 13 , 14 , 16 
.byte  18 , 20 , 22 , 24 , 26 , 28 , 30 , 32 
.byte  34 , 36 , 38 , 40 , 42 , 44 , 46 , 48 
.byte  50 , 51 , 53 , 55 , 56 , 57 , 59 , 60 
.byte  61 , 62 , 62 , 63 , 63 , 64 , 64 , 64 
.byte  64 , 64 , 63 , 63 , 62 , 62 , 61 , 60 
.byte  59 , 57 , 56 , 55 , 53 , 51 , 50 , 48 
.byte  46 , 44 , 42 , 40 , 38 , 36 , 34 , 32 
.byte  30 , 28 , 26 , 24 , 22 , 20 , 18 , 16 
.byte  14 , 13 , 11 , 9 , 8 , 7 , 5 , 4 
.byte  3 , 2 , 2 , 1 , 1 , 0 , 0 , 0 
.byte  0 , 0 , 1 , 1 , 2 , 2 , 3 , 4 
.byte  5 , 7 , 8 , 9 , 11 , 13 , 14 , 16 
.byte  18 , 20 , 22 , 24 , 26 , 28 , 30 , 32 
.byte  34 , 36 , 38 , 40 , 42 , 44 , 46 , 48 
.byte  50 , 51 , 53 , 55 , 56 , 57 , 59 , 60 
.byte  61 , 62 , 62 , 63 , 63 , 64 , 64 , 64 
.byte  64 , 64 , 63 , 63 , 62 , 62 , 61 , 60 
.byte  59 , 57 , 56 , 55 , 53 , 51 , 50 , 48 
.byte  46 , 44 , 42 , 40 , 38 , 36 , 34 , 32 
.byte  30 , 28 , 26 , 24 , 22 , 20 , 18 , 16 
.byte  14 , 13 , 11 , 9 , 8 , 7 , 5 , 4 
.byte  3 , 2 , 2 , 1 , 1 , 0 , 0 , 0 
.byte  0 , 0 , 1 , 1 , 2 , 2 , 3 , 4 
.byte  5 , 7 , 8 , 9 , 11 , 13 , 14 , 16 
.byte  18 , 20 , 22 , 24 , 26 , 28 , 30 , 32 
.byte  34 , 36 , 38 , 40 , 42 , 44 , 46 , 48 
.byte  50 , 51 , 53 , 55 , 56 , 57 , 59 , 60 
.byte  61 , 62 , 62 , 63 , 63 , 64 , 64 , 64 
.byte  64 , 64 , 63 , 63 , 62 , 62 , 61 , 60 
.byte  59 , 57 , 56 , 55 , 53 , 51 , 50 , 48 
.byte  46 , 44 , 42 , 40 , 38 , 36 , 34 , 32 
.byte  30 , 28 , 26 , 24 , 22 , 20 , 18 , 16 
.byte  14 , 13 , 11 , 9 , 8 , 7 , 5 , 4 
.byte  3 , 2 , 2 , 1 , 1 , 0 , 0 , 0 
.byte  0 , 0 , 1 , 1 , 2 , 2 , 3 , 4 
.byte  5 , 7 , 8 , 9 , 11 , 13 , 14 , 16 
.byte  18 , 20 , 22 , 24 , 26 , 28 , 30 , 32 

.end

